Bug 90266 - Unigine Heaven 4.0 logging vm faults since radeon/llvm: Run LLVM's instruction combining pass
Summary: Unigine Heaven 4.0 logging vm faults since radeon/llvm: Run LLVM's instructio...
Status: RESOLVED FIXED
Alias: None
Product: Mesa
Classification: Unclassified
Component: Drivers/Gallium/radeonsi (show other bugs)
Version: git
Hardware: x86-64 (AMD64) Linux (All)
: medium normal
Assignee: Default DRI bug account
QA Contact: Default DRI bug account
URL:
Whiteboard:
Keywords:
Depends on:
Blocks:
 
Reported: 2015-05-01 11:03 UTC by Andy Furniss
Modified: 2015-05-12 19:42 UTC (History)
0 users

See Also:
i915 platform:
i915 features:


Attachments
Heaven 4.0 R600_DEBUG=ps,vs,gs Bad (347.92 KB, application/octet-stream)
2015-05-01 11:06 UTC, Andy Furniss
Details
Heaven 4.0 R600_DEBUG=ps,vs,gs Good with mesa revert (357.19 KB, application/octet-stream)
2015-05-01 11:07 UTC, Andy Furniss
Details
Possible Fix (9.74 KB, patch)
2015-05-07 22:25 UTC, Tom Stellard
Details | Splinter Review

Note You need to log in before you can comment on or make changes to this bug.
Description Andy Furniss 2015-05-01 11:03:37 UTC
Related to 

https://bugs.freedesktop.org/show_bug.cgi?id=90056

Unlike valley I thought heaven 4.0 wasn't affected by above as it runs and looks OK.

There is however an issue, again "fixed" by reverting mesa commit 

commit c6d79ed289a75f13c65f011be870f7e43a0fedc7
Author: Tom Stellard <thomas.stellard@amd.com>
Date:   Fri Apr 10 17:07:16 2015 +0000

    radeon/llvm: Run LLVM's instruction combining pass


This issue is thousands of lines of logging like below.

This happens with or without the llvm fix in the valley bug.

Will attach R600_DEBUG=ps,vs,gs with and without above mesa commit reverted. The debug logs were done with todays llvm,mesa so the valley fix in in llvm.

The errors -

[ 7288.184664] VM fault (0x01, vmid 14) at page 185032279, read from TC (4)
[ 7288.184667] radeon 0000:01:00.0: GPU fault detected: 147 0x0afc0401
[ 7288.184668] radeon 0000:01:00.0:   VM_CONTEXT1_PROTECTION_FAULT_ADDR   0x0B075E57
[ 7288.184670] radeon 0000:01:00.0:   VM_CONTEXT1_PROTECTION_FAULT_STATUS 0x1C004001
[ 7288.184671] VM fault (0x01, vmid 14) at page 185032279, read from TC (4)
[ 7288.184695] radeon 0000:01:00.0: GPU fault detected: 147 0x0afc0401
[ 7288.184696] radeon 0000:01:00.0:   VM_CONTEXT1_PROTECTION_FAULT_ADDR   0x0B075E57
[ 7288.184698] radeon 0000:01:00.0:   VM_CONTEXT1_PROTECTION_FAULT_STATUS 0x1C004001
Comment 1 Andy Furniss 2015-05-01 11:06:10 UTC
Created attachment 115494 [details]
Heaven 4.0 R600_DEBUG=ps,vs,gs Bad
Comment 2 Andy Furniss 2015-05-01 11:07:23 UTC
Created attachment 115495 [details]
Heaven 4.0 R600_DEBUG=ps,vs,gs Good with mesa revert
Comment 3 Arek Ruśniak 2015-05-01 21:12:15 UTC
i can confirm this on cape verde:

dmesg:
[  956.234491] VM fault (0x01, vmid 4) at page 185033268, read from TC (4)
[  956.234500] radeon 0000:01:00.0: GPU fault detected: 147 0x06880401
[  956.234500] radeon 0000:01:00.0:   VM_CONTEXT1_PROTECTION_FAULT_ADDR   0x0B076234
[  956.234501] radeon 0000:01:00.0:   VM_CONTEXT1_PROTECTION_FAULT_STATUS 0x08004001
[  956.234502] VM fault (0x01, vmid 4) at page 185033268, read from TC (4)
[  956.234519] radeon 0000:01:00.0: GPU fault detected: 147 0x06880401
[  956.234519] radeon 0000:01:00.0:   VM_CONTEXT1_PROTECTION_FAULT_ADDR   0x0B076234
[  956.234520] radeon 0000:01:00.0:   VM_CONTEXT1_PROTECTION_FAULT_STATUS 0x08004001
Comment 4 Tom Stellard 2015-05-04 15:15:51 UTC
(In reply to Andy Furniss from comment #0)
> Related to 
> 
> https://bugs.freedesktop.org/show_bug.cgi?id=90056
> 
> Unlike valley I thought heaven 4.0 wasn't affected by above as it runs and
> looks OK.
> 
> There is however an issue, again "fixed" by reverting mesa commit 
> 

Thanks for the report, I just have a few qustions:

Are there any problems with Valley after the fix for Bug 90056 was committed?

Does the problem reported in this bug for Heaven still happen if you keep the InsCombine pass enabled, but revert the fix from Bug 90056?
Comment 5 Andy Furniss 2015-05-04 16:28:20 UTC
(In reply to Tom Stellard from comment #4)
> (In reply to Andy Furniss from comment #0)
> > Related to 
> > 
> > https://bugs.freedesktop.org/show_bug.cgi?id=90056
> > 
> > Unlike valley I thought heaven 4.0 wasn't affected by above as it runs and
> > looks OK.
> > 
> > There is however an issue, again "fixed" by reverting mesa commit 
> > 
> 
> Thanks for the report, I just have a few qustions:
> 
> Are there any problems with Valley after the fix for Bug 90056 was committed?

No, Valley is OK

> Does the problem reported in this bug for Heaven still happen if you keep
> the InsCombine pass enabled, but revert the fix from Bug 90056?

Yes with or without the fix Heaven logs the errors.

Initially tested on an older llvm with and without the patch from -

https://bugs.freedesktop.org/show_bug.cgi?id=90056#c14

and again just now by reverting "R600/SI: Fix verifier errors from the SIAnnotateControlFlow" on a more recent llvm.
Comment 6 Tom Stellard 2015-05-07 22:25:50 UTC
Created attachment 115625 [details] [review]
Possible Fix

This patch should fix the issue, can you test?
Comment 7 Andy Furniss 2015-05-08 11:06:07 UTC
(In reply to Tom Stellard from comment #6)
> Created attachment 115625 [details] [review] [review]
> Possible Fix
> 
> This patch should fix the issue, can you test?

Yes, this fixes it.
Comment 8 Arek Ruśniak 2015-05-09 11:17:01 UTC
thx Tom, heaven works as before
Comment 9 Tom Stellard 2015-05-12 19:26:48 UTC
Fix committed to LLVM: r237164


Use of freedesktop.org services, including Bugzilla, is subject to our Code of Conduct. How we collect and use information is described in our Privacy Policy.